#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/file.h>

void main(void)
{
	char buf[1040],*ip,*ptr,*contentlen=getenv("CONTENT_LENGTH"),
		*name=getenv("REMOTE_USER");
	int fd;
	unsigned a=0,b=0,c=0,d=0,postlen=0;
	struct _inf { char name[16],ip[16]; } inf;
	FILE *f;

	//read POST data
	if(contentlen!=NULL)
		postlen=atoi(contentlen);
	if(postlen>1024)
		postlen=1024;
	fgets(buf,postlen+1,stdin);

	//header
	printf("Content-type: text/html\n\n<HTML><HEAD>"
		"<TITLE>Update</TITLE></HEAD>\n<BODY>");

	ip=strstr(buf,"ip=");
	if(ip==NULL) //before submit, show stupid form
	{
		printf(	"<FORM ACTION="SCRIPT_LOCATION" METHOD=post>\n"
			"IP: <INPUT TYPE=text NAME=ip SIZE=15 MAXLENGTH=15>\n"
				"<INPUT TYPE=submit VALUE=Update></FORM>");
	}
	else //after submit, update shit
	{
		//ip contains numbers and dots only
		ptr=(ip+=3);
		while(*ptr=='.'||(*ptr>='0'&&*ptr<='9'))
			ptr++;
		*ptr=0;
		//limit to 15 chars each
		if(strlen(name)>15)
			name[15]=0;
		if(strlen(ip)>15)
			ip[15]=0;
		//read numbers from buffer
		sscanf(ip,"%d.%d.%d.%d",&a,&b,&c,&d);
		a&=255;
		b&=255;
		c&=255;
		d&=255;
		//guarantee a properly formatted ip
		sprintf(ip,"%d.%d.%d.%d",a,b,c,d);

		//open db of hosts
		if((fd=open(DYN_DAT_LOCATION"/db",O_RDWR))==-1)
		{
			printf("internal error");
		}
		else
		{
			//wait for file lock
			flock(fd,LOCK_EX);
			f=fdopen(fd,"r+");

			//search for matching host
			for(;;)
			{
				fread(&inf,sizeof(struct _inf),1,f);
				if(!strcmp(inf.name,name))
				{
					//back up to overwrite match
					fseek(f,-sizeof(struct _inf),SEEK_CUR);
					break;
				}
				//end of file, no match, append new host
				if(feof(f))
					break;
			}
			//write new host info to file
			strcpy(inf.name,name);
			strcpy(inf.ip,ip);
			fwrite(&inf,sizeof(struct _inf),1,f);
			//write file, then unlock and close
			fflush(f);
			flock(fd,LOCK_UN);
			fclose(f);

#ifdef INSTANT_UPDATE
			//restart named daemon (probably suid)
			system(DYN_DAT_LOCATION"/restart.named");
#endif

			printf("%s updated to %s",name,ip);
		}
	}
	printf("</BODY></HTML>\n");
}
